/***************************************************************************
                          calphavalidator.cpp  -  description
                             -------------------
    begin                : Sat May 5 2001
    copyright            : (C) 2001 by Mihnea Balta
    email                : mihnea@tomrad.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "calphavalidator.h"

CAlphaValidator::CAlphaValidator(QWidget *parent, const char *name ) : QValidator(parent,name) {
}

CAlphaValidator::~CAlphaValidator(){
}

bool isLetter(const QChar &c){
	if( ((c>='A') && (c<='Z')) || ((c>='a') && (c<='z')) )
		return true;
	else
		return false;
}

bool isNumber(const QChar &c){
	if ( (c>='0') && (c<='9') )
		return true;
	else
		return false;
}

QValidator::State CAlphaValidator::validate(QString &input, int &pos) const{
	if(input.length()==0)
		return Intermediate;
	if( (!isLetter(input[0])) && (input[0] != '_') )
		return Invalid;
	for(int i=1; i<input.length(); i++)
		if( (!isNumber(input[i])) && (!isLetter(input[i])) && (input[i] != '_') )
			return Invalid;
	return Acceptable;
}

