/***************************************************************************
                          cfldedit.cpp  -  description
                             -------------------
    begin                : Sat May 5 2001
    copyright            : (C) 2001 by Mihnea Balta
    email                : mihnea@tomrad.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cfldedit.h"
#include <iostream>
#include "plugin.h"
#include <math.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qmultilineedit.h>
#include <qpushbutton.h>
#include <qfont.h>

extern CPlugin crp;

CFldEdit::CFldEdit(QWidget *parent, const char *name ) : CmetaFldEdit(parent,name, TRUE) {
	int i, j;
	QCheckBox *qb;
	QFont f;
	
	for(i=0; i<crp.typeCount(); i++)
		typeCombo->insertItem(crp.typeName(i));
	keyCombo->insertItem("No");
	keyCombo->insertItem("Primary");
	av = new CAlphaValidator;
	nameEd->setValidator(av);
	iv = new QIntValidator(this);
	iv->setRange(1, 32768);
	sizeEdit->setValidator(iv);
	modifs.push_back(notNullCheck);
	modifs.push_back(uniqueCheck);
	i = int(ceil(crp.modifCount()/3.0)*23);
	setFixedHeight(height() + i);
	modifbox->setFixedHeight(89 + i);
	clabel->move(clabel->x(), clabel->y() +i);
	commentEdit->move(commentEdit->x(), commentEdit->y() +i);
	okbut->move(okbut->x(), okbut->y()+i);
	cancelbut->move(cancelbut->x(), cancelbut->y()+i);
	line2->move(line2->x(), line2->y()+i);
	j = keyCombo->y() + 10;
	for(i=0; i<crp.modifCount(); i++){
		qb = new QCheckBox(QString(crp.getModifName(i)), modifbox, 0);
		qb->resize(20 + QFontMetrics(f).width(QString(crp.getModifName(i))), QFontMetrics(f).height());
		qb->move(20 + (i%3)*(modifbox->width()-10)/3, j + (i/3 + 1)* (qb->height() +4 ));
		modifs.push_back(qb);
	}
}

CFldEdit::~CFldEdit(){
	delete iv;
	delete av;
}

void CFldEdit::setcombo(QComboBox *qb, const QString &s){
	int i;
	for(i=0; i<qb->count(); i++)
		if(s == qb->text(i)){
			qb->setCurrentItem(i);
			return;
		}
	//we'd better never get here
	qb->setCurrentItem(0);
}

void CFldEdit::type_chg(){
	int i=typeCombo->currentItem();
	int j;
	
	if(crp.hasSize(i))
		sizeEdit->setEnabled(true);
	else{
		sizeEdit->setEnabled(false);
		sizeEdit->setText("0");
	}
	
	if(crp.canbekey(i))
		keyCombo->setEnabled(true);
	else{
		setcombo(keyCombo, "No");
		keyCombo->setEnabled(false);
	}
	
	for(j=0; j<crp.modifCount()+2; j++){
		cerr << crp.canModif(i, j) << endl;
		switch(crp.canModif(i, j)){
			case MODIF_ENABLED:
				modifs[j]->setEnabled(true);
				cerr << "Enabled\n";
				break;
			case MODIF_DISABLED:
				modifs[j]->setEnabled(false);
				modifs[j]->setChecked(false);
				break;
			case MODIF_FORCED:
				modifs[j]->setEnabled(false);
				modifs[j]->setChecked(true);
				break;
		}
	}
}

void CFldEdit::key_type_chg(){
}

