/***************************************************************************
                          cobjtreeitem.h  -  description
                             -------------------
    begin                : Mon May 7 2001
    copyright            : (C) 2001 by Mihnea Balta
    email                : mihnea@tomrad.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef COBJTREEITEM_H
#define COBJTREEITEM_H

#include <qlistview.h>
#include <qcanvas.h>

/****
  @author Mihnea Balta
  This class represents items that are stored in the ObjectTree.
  It extends QListViewItem to provide type identification and stores
  	the address of the object represented by the item. I don't really
  	like the void* hack, maybe someday I'll move the association between
  	tree objects and real objects in CObjectTree (using hashes).
****/

#define TABLE_ROOT 1
#define REL_ROOT 2
#define FUNC_ROOT 3
#define TABLE_IT 4
#define REL_IT 5
#define FUNC_IT 6
#define SEQ_ROOT 7
#define SEQ_IT 8

class CObjectTree;

class CObjTreeItem : public QListViewItem  {
public:
	CObjTreeItem(void *realobj, int type, CObjectTree *parent, CObjTreeItem *after);
	CObjTreeItem(void *realobj, int type, CObjectTree *parent);
	CObjTreeItem(void *&realobj, int type, CObjTreeItem *parent, CObjTreeItem *after);
	CObjTreeItem(void *&realobj, int type, CObjTreeItem *parent);
	~CObjTreeItem();
	int		getType() const { return objtype; }
	void	*getObject() const { return obj; }
private:
	void	*obj;
	int		objtype;
};

#endif
