/***************************************************************************
                          crelationitem.h  -  description
                             -------------------
    begin                : Mon May 7 2001
    copyright            : (C) 2001 by Mihnea Balta
    email                : mihnea@tomrad.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CRELATIONITEM_H
#define CRELATIONITEM_H

#include <qcanvas.h>
#include "ctable.h"

class CRelationItem;
class CView;
#include "cview.h"

/****
  @author Mihnea Balta
  CRelationItem is the graphic representation of an item.
  It is contained in CView.
****/

static const int relationRTTI = 99902;

class CRelationItem : public QCanvasPolygon {
public: 
	CRelationItem(CRelation *relref, QCanvas *);
	~CRelationItem();
	CRelation	*getRel() const { return rel;}
	void			setRel(CRelation *newrel);
	int				rtti() const { return relationRTTI; }
	bool			visible;
protected:
	void		drawShape(QPainter &p);
private:
	CRelation	*rel;
	CView			*view;
};

#endif
