/***************************************************************************
                          creledit.cpp  -  description
                             -------------------
    begin                : Mon May 7 2001
    copyright            : (C) 2001 by Mihnea Balta
    email                : mihnea@tomrad.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "creledit.h"
#include "cview.h"
#include <iostream>
#include "plugin.h"

extern CPlugin crp;

CRelEdit::CRelEdit(QWidget *parent, const char *name ) : CmetaRelEdit(parent, name, TRUE) {
	r_id = 0;
	QCanvasItemList l = ((CView *)(parent))->canvas()->allItems();
	for(QCanvasItemList::Iterator it = l.begin(); it!=l.end(); it++)
		if((*it)->rtti() == tableRTTI){
			CTableItem *item = (CTableItem *)(*it);
			QString s;
			s = item->getTable()->name();
			tables.push_back(item->getTable());
			fromTable->insertItem(s);
			toTable->insertItem(s);
		}
	fromTableChanged();
	toTableChanged();
}

CRelEdit::~CRelEdit(){
}

void CRelEdit::accept(){
	if(relName->text().length() == 0){
		KMessageBox::sorry(this, "You didn't specify a name for the relation", "Error");
		return;
	}
	if(fromTable->currentText() == toTable->currentText()){
		KMessageBox::sorry(this, "Cannot create relation from one table to itself", "Error");
		return;
	}
	QDialog::accept();
}

void CRelEdit::fromTableChanged(){
	fromId = tables[fromTable->currentItem()]->getId();
	fldlist l = tables[fromTable->currentItem()]->getFields();
	fromField->clear();
	fromFldIds.clear();
	for(fldlist::iterator it = l.begin(); it != l.end(); it++)
		if(crp.canbekey(it->type_idx)){
				fromField->insertItem(it->name);
				fromFldIds.push_back(it->getId());
			}
	fromFldChanged();
}

void CRelEdit::toTableChanged(){
	toId = tables[toTable->currentItem()]->getId();
	fromFldChanged();
}

void CRelEdit::fromFldChanged(){
	fldlist l = tables[fromTable->currentItem()]->getFields();
	int fromtype=0;
	
	for(fldlist::iterator it = l.begin(); it != l.end(); it++)
		if(fromField->currentText() == it->name){
			fromtype = it->type_idx;
			break;
		}
	l = tables[toTable->currentItem()]->getFields();
	toField->clear();
	toFldIds.clear();
	for(fldlist::iterator it = l.begin(); it != l.end(); it++)
		if(crp.validref(fromtype, it->type_idx)){
			toField->insertItem(it->name);
			toFldIds.push_back(it->getId());
		}
}

void CRelEdit::toFldChanged(){
}

void CRelEdit::setRelation(CRelation *rel){
	r_id = rel->getId();
	bool setf=false, sett=false;
	relName->setText(rel->name);
	int i;
	for(i=0; i<tables.size(); i++){
		if(tables[i]->getId() == rel->fromTbl){
			fromTable->setCurrentItem(i);
			setf = true;
		}
		if(tables[i]->getId() == rel->toTbl){
			toTable->setCurrentItem(i);
			sett = true;
		}
		if(sett && setf)
			break;
	}
	fromTableChanged();
	toTableChanged();
	idlist::iterator it = fromFldIds.begin();
	for(i=0; it != fromFldIds.end(); i++, it++)
		if(*it == rel->fromFld){
			fromField->setCurrentItem(i);
			break;
		}
	for(i=0, it = toFldIds.begin(); it != toFldIds.end(); i++, it++)
		if(*it == rel->toFld){
			toField->setCurrentItem(i);
			break;
		}
}

CRelation* CRelEdit::getRelation(){
	CRelation *rel = new CRelation(r_id);
	rel->name = relName->text();
	rel->comment = relComment->text();
	rel->fromTbl = tables[fromTable->currentItem()]->getId();
	rel->toTbl = tables[toTable->currentItem()]->getId();
	idlist::iterator it = fromFldIds.begin();
	for(int i=0; i<fromField->currentItem(); i++, it++);
	rel->fromFld = *it;
	it = toFldIds.begin();
	for(int i=0; i<toField->currentItem(); i++, it++);
	rel->toFld = *it;
	return rel;
}
