/***************************************************************************
                          creledit.h  -  description
                             -------------------
    begin                : Mon May 7 2001
    copyright            : (C) 2001 by Mihnea Balta
    email                : mihnea@tomrad.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CRELEDIT_H
#define CRELEDIT_H

#include <qwidget.h>
#include <qcanvas.h>
#include <qcombobox.h>
#include <qlineedit.h>
#include <qmultilineedit.h>
#include "cmetareledit.h"
#include "ctableitem.h"

#include <vector>

/****
  @author Mihnea Balta
  CRelEdit is the relation editor.
  It inherits CmetaRelEdit which is a generic object created
  	from cmetareledit.ui (QTDesigner)
****/

typedef vector<CTable *> tablevect;

class CRelEdit : public CmetaRelEdit  {
   Q_OBJECT
public: 
	CRelEdit(QWidget *parent=0, const char *name=0);
	~CRelEdit();
	void			setRelation(CRelation*);
	CRelation *getRelation();
public slots:
	void	accept();
	void fromTableChanged();
	void toTableChanged();
	void fromFldChanged();
	void toFldChanged();
private:
	tablevect	tables;
	uint			fromId;
	uint			toId;
	idlist		fromFldIds;
	idlist		toFldIds;
	uint			r_id;
};

#endif
