/***************************************************************************
                          ctableed.h  -  description
                             -------------------
    begin                : Wed May 2 2001
    copyright            : (C) 2001 by Mihnea Balta
    email                : mihnea@tomrad.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CTABLEED_H
#define CTABLEED_H

#include <qwidget.h>
#include <qtable.h>
#include <qlineedit.h>
#include <qmultilineedit.h>
#include <qcheckbox.h>
#include <kmessagebox.h>
#include <list>

#include "cmetatableed.h"
#include "cfldedit.h"
#include "creledit.h"
#include "calphavalidator.h"

/****
  @author Mihnea Balta
  CTableEd is the table editor.
  It allows adding/editing/deleting of the table's components.
  It inherits CmetaTableEd which is a generic object created
  	from cmetatableed.ui (QTDesigner)
****/

typedef list<int> intlist;

class CTableEd : public CmetaTableEd  {
   Q_OBJECT
public: 
	CTableEd(bool newT, QWidget *parent=0, const char *name=0);
	~CTableEd();
	CTable	*getTable();
	void 		setTable(CTable *newtbl);
public slots:
	void fld_new();
	void fld_edit();
	void fld_del();
private:
	CAlphaValidator *v;
	void						setcombo(QComboBox *qb, const QString &s);
	void						setcheck(QCheckBox *qc, const QString &s);
	unsigned int		t_id;
	idlist					fieldIDs;
	idlist					relationlist;
};

#endif
