/***************************************************************************
                          ctableitem.h  -  description
                             ----------------------
    begin                : Sun Apr 29 2001
    copyright            : (C) 2001 by Mihnea Balta
    email                : mihnea@tomrad.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CTABLEITEM_H
#define CTABLEITEM_H

#include <qwidget.h>
#include <qcanvas.h>
#include <qpainter.h>
#include <kmessagebox.h>

#include "ctable.h"

/****
  @author Mihnea Balta
  CTableItem represents the graphic part of a table.
  It is contained in CView.
  It contains a CTable object which contains the functional
  	information about the table it represents.
****/

const int tableRTTI=99901;

/* XPM */
static const char* const pk[]={
"16 16 3 1",
". c None",
"# c #c00000",
"a c #ffffff",
"................",
"................",
"..############..",
"..############..",
"..##aaa##a##a#..",
"..##a##a#a#a##..",
"..##a##a#a#a##..",
"..##aaa##aa###..",
"..##a####a#a##..",
"..##a####a#a##..",
"..##a####a##a#..",
"..##a####a##a#..",
"..############..",
"..############..",
"................",
"................"};

/* XPM */
static const char* const fk[]={
"16 16 3 1",
". c None",
"# c #0000c0",
"a c #ffffff",
"................",
"................",
"..############..",
"..############..",
"..#aaaa#a##a##..",
"..#a####a#a###..",
"..#a####a#a###..",
"..#aaa##aa####..",
"..#a####a#a###..",
"..#a####a#a###..",
"..#a####a##a##..",
"..#a####a##a##..",
"..############..",
"..############..",
"................",
"................"};

class CTableItem : public QCanvasRectangle  {
public:
	CTableItem(CTable *table, int x, int y, QCanvas *canvas);
	~CTableItem();
	int			rtti () const { return tableRTTI; }
	bool		hit(const QPoint&);
	//distance from hitpoint to upper left corner
	QPoint	distUL;
	//distance from hitpoint to lower right corner
	QPoint	distLR;
	CTable	*getTable();
	void		setTable(CTable *newtable);
	void		setFocus(bool focus);
	bool		focused();
	bool		visible;
protected:
	void		drawShape(QPainter &p);
private:
	bool		hasFocus;
	CTable	*tbl;
private slots:
	void		resize();
};

#endif
