/***************************************************************************
                          dbdesign.h  -  description
                             -------------------
    begin                : Mon Apr  9 18:56:14 EEST 2001
    copyright            : (C) 2001 by Mihnea Balta
    email                : mihnea@tomrad.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DBDESIGN_H
#define DBDESIGN_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kapp.h>
#include <qwidget.h>
#include <kmenubar.h>
#include <kmainwindow.h>
#include <kaction.h>
#include <kstdaction.h>
#include <klistview.h>
#include <qlayout.h>
#include <qcanvas.h>
#include <qpopupmenu.h>
#include <vector>

#include "cview.h"
#include "cobjecttree.h"
#include "ctableed.h"

struct PlugInfo{
	QString name;
	QString path;
};

typedef vector<PlugInfo> VPlugins;

/** DbDesign is the base class of the project */
class DbDesign : public KMainWindow
{
  Q_OBJECT 
  public:
    DbDesign(QWidget* parent=0, const char *name=0);
    ~DbDesign();
  	
  	CObjectTree	*ltree;
  	CView				*dbview;
  	
  	void				setTblName(QString newname);
		KToggleAction	*cfDrop;
		KSelectAction	*vwView;
	
	public slots:
	  void	slotNew();
	  void	slotOpen();
	  void	slotSave();
	  void	slotSaveAs();
	  void	slotQuit();
	  void	slotImport();
	  void	slotExport();
	  void	slotPlugin();
	  void	slotView();
	  int		refreshPlugins();

  private:
  	void					initAct();
  	KAction				*fileNew;
  	KAction				*fileOpen;
  	KAction				*fileSave;
  	KAction				*fileSaveAs;
  	KSelectAction	*fileImport;
  	KSelectAction	*fileExport;
  	KAction				*fileQuit;
  	KAction				*objCrTable;
  	KAction				*objCrRel;
  	KAction				*editEditTable;
  	KAction				*editDelTable;
		KAction				*editClear;
		KSelectAction	*cfPlugin;
		KAction				*vwConf;
		KActionSeparator *vwSep;
  	QGridLayout		*gl;
  	QString				dbname;
  	QString				filename;
  	VPlugins			plugins;
  	int						stdplugidx;
  	
  protected:
  	bool					queryClose();
};

#endif
