/***************************************************************************
                          plugin.h  -  description
                             -------------------
    begin                : Sat May 26 2001
    copyright            : (C) 2001 by Mihnea Balta
    email                : mihnea@tomrad.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PLUGIN_H
#define PLUGIN_H

#include <qstring.h>

/****
  @author Mihnea Balta
  This is the plugin interface class.
****/

/****
	libtool is NOT thread-safe, so I can't use it.
	if I do, kwin crashes.
	Note: on *BSD don't try linking to libdl because
				dlopen() is part of libc.
****/

#define MODIF_ENABLED 0
#define MODIF_DISABLED 1
#define MODIF_FORCED 2

#define SEQS 0x1

class CPlugin {
public: 
	CPlugin();
	CPlugin(QString fname);
	~CPlugin();
	void					load(QString fname);
	QString				name();
	int						typeCount();
	const char*		typeName(int type_idx);
	bool					hasSize(int type_idx);
	bool					canbekey(int type_idx);
	bool					validref(int type1, int type2);
	int						modifCount();
	QString				getModifName(int idx);
	int						getModifMask(int idx);
	const char*		getModifVal(int idx);
	int						canModif(int type_idx, int modif_idx);
	bool					showable(int type_idx);
	unsigned int	objAffinity();
	bool					connect_db(QString host, int port, QString user, QString pass, QString db);
	bool					execSQL(QString sql);
	void					close_db();
	char*					lastDbError();
	char**				getDbNames(QString host, int port, QString user, QString pass);
	const bool		ok();
private:
	bool				initOk;
	void				*handle;
	const char*	(*getname_ptr)();
	int					(*typecnt_ptr)();
	const char*	(*typename_ptr)(int);
	bool 				(*has_size_ptr)(int);
	bool 				(*canbekey_ptr)(int);
	bool 				(*validref_ptr)(int, int);
	int					(*modifcnt_ptr)();
	const char*	(*modifname_ptr)(int);
	const char*	(*modifval_ptr)(int);
	int					(*modifmask_ptr)(int);
	int 				(*canmodif_ptr)(int, int);
	bool				(*showable_ptr)(int);
	unsigned int (*affinity_ptr)();
	bool				(*connect_ptr)(const char*, int, const char*, const char*, const char*);
	bool				(*exec_ptr)(const char*);
	void				(*close_ptr)();
	char*				(*last_error_ptr)();
	char**			(*get_databases_ptr)(const char*, int, const char*, const char*);
};

#endif
