/***************************************************************************
                          nullplug.h  -  description
                             -------------------
    begin                : Sat May 26 2001
    copyright            : (C) 2001 by Mihnea Balta
    email                : mihnea@tomrad.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NULLPLUG_H
#define NULLPLUG_H

#include <dbdesign/dbd_plugin.h>

static int typecount = 9;

static const char* const typenames[] = {
	"int",
	"unsigned int",
	"char",
	"varchar",
	"text",
	"date",
	"time",
	"constraint",
	"check",
	0
};

static const int with_size[] = {
	1, 1, 1, 1, 0, 0, 0, 0, 0
};

static const int keytypes[] = {
	1, 1, 1, 1, 1, 1, 1, 0, 0
};

static const int visual[] = {
	1, 1, 1, 1, 1, 1, 1, 1, 0
};

static const int vrefs[9][9] = {
	{1, 1, 0, 0, 0, 0, 0, 0, 0},
	{1, 1, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 1, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 1, 1, 0, 0, 0, 0},
	{0, 0, 0, 1, 1, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 1, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 1, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0}
};

static const int can_modif[9][2] = {
	{MODIF_ENABLED, MODIF_ENABLED},
	{MODIF_ENABLED, MODIF_ENABLED},
	{MODIF_ENABLED, MODIF_ENABLED},
	{MODIF_ENABLED, MODIF_ENABLED},
	{MODIF_ENABLED, MODIF_ENABLED},
	{MODIF_ENABLED, MODIF_ENABLED},
	{MODIF_ENABLED, MODIF_ENABLED},
	{MODIF_DISABLED, MODIF_DISABLED},
	{MODIF_DISABLED, MODIF_DISABLED},
};

#endif
