/***************************************************************************
                          svrdlg.cpp  -  description
                             -------------------
    begin                : Sat Jun 9 2001
    copyright            : (C) 2001 by Mihnea Balta
    email                : mihnea@tomrad.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "svrdlg.h"
#include <kmessagebox.h>
#include <qlistbox.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qlineedit.h>
#include "plugin.h"

extern CPlugin crp;

CSvrDlg::CSvrDlg(bool import, QWidget *parent, const char *name ) : CmetaSvrDlg(parent, name, true){
	if(import){
		cb1->setEnabled(false);
		cb2->setEnabled(false);
	}
	else{
		cb1->setEnabled(true);
		cb2->setEnabled(true);
	}
	lb1->clear();
}

CSvrDlg::~CSvrDlg(){
}

void CSvrDlg::slot_list(){
	lb1->clear();
	char **dbnames = crp.getDbNames(svrName->currentText(), portNum->text().toInt(), user->text(), pass->text());
	if(crp.lastDbError()){
		KMessageBox::error(this, QString("Could not list databases. Reason: ") + crp.lastDbError(), "DB server error");
		return;
	}
	if(!dbnames)
		return;
	while(*dbnames){
		lb1->insertItem(QString(*dbnames));
		dbnames++;
	}
}

void CSvrDlg::slot_selDb(){
	dbname->setText(lb1->currentText());
}
