/***************************************************************************
                          viewconf.cpp  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Mihnea Balta
    email                : mihnea@tomrad.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "viewconf.h"
#include "qlistbox.h"
#include "qcombobox.h"
#include <qpushbutton.h>
#include <iostream>
#include <klineeditdlg.h>

CViewConf::CViewConf(QWidget *parent, const char *name ) : CmetaViewConf(parent, name, TRUE){
	PushButton2->setAccel(Key_Left);
	PushButton3->setAccel(Key_Right);
}

CViewConf::~CViewConf(){
}

void CViewConf::slot_add(){
	int id;
	if(!avail->currentText().isNull())
		id = items[avail->currentText()];
	else
		return;
	views[vname->currentText()][id] = true;
	slot_changed();
}

void CViewConf::slot_remove(){
	int id;
	if(!contained->currentText().isNull())
		id = items[contained->currentText()];
	else
		return;
	views[vname->currentText()][id] = false;
	slot_changed();
}

void CViewConf::slot_new(){
	view_map nv;
	QString name;
	bool ok;
	
	name = KLineEditDlg::getText("Name:", "", &ok, this);
	if(!ok)
		return;
	
	nv.clear();
	views[name] = nv;
	vname->insertItem(name);
	vname->setCurrentItem(vname->count()-1);
	slot_changed();
}

void CViewConf::slot_delete(){
	views.remove(vname->currentText());
	vname->removeItem(vname->currentItem());
	slot_changed();
}

void CViewConf::slot_changed(){
	view_map view = views[vname->currentText()];
	
	contained->clear();
	avail->clear();
	for(item_map::Iterator it=items.begin(); it!=items.end(); it++)
		if(view[it.data()])
			contained->insertItem((QString)it.key());
		else
			avail->insertItem((QString)it.key());
}

void CViewConf::set_views(viewlist& nv, item_map& newi){
	views = nv;
	items = newi;
	
	vname->clear();
	for(viewlist::Iterator it=views.begin(); it!=views.end(); it++)
//		if((QString)it.key() != "All")
			vname->insertItem((QString)it.key());
	slot_changed();
}

QString CViewConf::get_current(){
	return vname->currentText();
}
