/***************************************************************************
                          viewconf.h  -  description
                             -------------------
    begin                : Mon Jun 11 2001
    copyright            : (C) 2001 by Mihnea Balta
    email                : mihnea@tomrad.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VIEWCONF_H
#define VIEWCONF_H

#include <qwidget.h>
#include <metaviewconf.h>
#include <qmap.h>
#include <qstring.h>

/**
  *@author Mihnea Balta
  */

typedef QMap<int, bool> view_map;
typedef QMap<QString, view_map> viewlist;
typedef QMap<QString, int> item_map;

class CViewConf : public CmetaViewConf  {
   Q_OBJECT
public: 
	CViewConf(QWidget *parent=0, const char *name=0);
	~CViewConf();
	void 			set_views(viewlist& newv, item_map& newi);
	viewlist	get_views() { return views; }
	QString		get_current();
public slots:
	void			slot_add();
	void			slot_remove();
	void			slot_new();
	void			slot_delete();
	void			slot_changed();
private:
	viewlist	views;
	item_map	items;
};

#endif
